/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.unis.purchaseAndSalesSupervision.modular.bizPssRepaymentRiskWarn.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.unis.basic.info.modular.orgInfo.entity.OrgInfo;
import com.unis.basic.info.modular.orgInfo.mapper.OrgInfoMapper;
import com.unis.purchaseAndSalesSupervision.modular.bizPssRepaymentRiskWarn.param.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.unis.common.enums.CommonSortOrderEnum;
import com.unis.common.exception.CommonException;
import com.unis.common.page.CommonPageRequest;
import com.unis.purchaseAndSalesSupervision.modular.bizPssRepaymentRiskWarn.entity.BizPssRepaymentRiskWarn;
import com.unis.purchaseAndSalesSupervision.modular.bizPssRepaymentRiskWarn.mapper.BizPssRepaymentRiskWarnMapper;
import com.unis.purchaseAndSalesSupervision.modular.bizPssRepaymentRiskWarn.service.BizPssRepaymentRiskWarnService;

import java.util.List;

/**
 * 财务类业务监管-偿还风险预警表Service接口实现类
 *
 * @author hjc
 * @date  2024/06/13 14:42
 **/
@Service
public class BizPssRepaymentRiskWarnServiceImpl extends ServiceImpl<BizPssRepaymentRiskWarnMapper, BizPssRepaymentRiskWarn> implements BizPssRepaymentRiskWarnService {

    @Autowired
    private BizPssRepaymentRiskWarnMapper bizPssRepaymentRiskWarnMapper;

    @Autowired
    private OrgInfoMapper orgInfoMapper;
    @Override
    public Page<BizPssRepaymentRiskWarn> page(BizPssRepaymentRiskWarnPageParam pageParam) {
/*        QueryWrapper<BizPssRepaymentRiskWarn> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isAllNotEmpty(bizPssRepaymentRiskWarnPageParam.getSortField(), bizPssRepaymentRiskWarnPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(bizPssRepaymentRiskWarnPageParam.getSortOrder());
            queryWrapper.orderBy(true, bizPssRepaymentRiskWarnPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(bizPssRepaymentRiskWarnPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(BizPssRepaymentRiskWarn::getId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);*/
        Page<BizPssRepaymentRiskWarn> page = new Page<>(pageParam.getCurrent(), pageParam.getSize());
        return bizPssRepaymentRiskWarnMapper.selectMyPage(page,pageParam.getOrgName());

    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(BizPssRepaymentRiskWarnAddParam bizPssRepaymentRiskWarnAddParam) {
        BizPssRepaymentRiskWarn bizPssRepaymentRiskWarn = BeanUtil.toBean(bizPssRepaymentRiskWarnAddParam, BizPssRepaymentRiskWarn.class);
        this.save(bizPssRepaymentRiskWarn);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(BizPssRepaymentRiskWarnEditParam bizPssRepaymentRiskWarnEditParam) {
        BizPssRepaymentRiskWarn bizPssRepaymentRiskWarn = this.queryEntity(bizPssRepaymentRiskWarnEditParam.getId());
        BeanUtil.copyProperties(bizPssRepaymentRiskWarnEditParam, bizPssRepaymentRiskWarn);
        this.updateById(bizPssRepaymentRiskWarn);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<BizPssRepaymentRiskWarnIdParam> bizPssRepaymentRiskWarnIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(bizPssRepaymentRiskWarnIdParamList, BizPssRepaymentRiskWarnIdParam::getId));
    }

    @Override
    public BizPssRepaymentRiskWarn detail(BizPssRepaymentRiskWarnIdParam bizPssRepaymentRiskWarnIdParam) {
        return this.queryEntity(bizPssRepaymentRiskWarnIdParam.getId());
    }

    @Override
    public BizPssRepaymentRiskWarn queryEntity(String id) {
        BizPssRepaymentRiskWarn bizPssRepaymentRiskWarn = this.getById(id);
        if(ObjectUtil.isEmpty(bizPssRepaymentRiskWarn)) {
            throw new CommonException("财务类业务监管-偿还风险预警表不存在，id值为：{}", id);
        }
        return bizPssRepaymentRiskWarn;
    }

    /**
     * 获取库区信息
     *
     * @author hjc
     * @date  2024/06/13 14:42
     */
    @Override
    public List<OrgInfo> getOrgInfoIdAndName() {
      return orgInfoMapper.selectList(null);
    }
}
